/*
 * $URL$
 * $Id$
 * $Revision$
 */

package org.postgresql.util.dataio;

import java.io.IOException;
import java.io.InputStream;

/**
 *
 * @author Radosław Smogura
 */
public class PGByteaTextInputStream_8_4 extends InputStream {
    private final long trimSize;
    
    private int position;
    
    /** Holds number of read bytes, to trim stream if needed. */
    private volatile long read;
    
    private final byte[] byteaBytes;

    public PGByteaTextInputStream_8_4(byte[] byteaBytes) {
        this(byteaBytes, Long.MAX_VALUE);
    }
    
    public PGByteaTextInputStream_8_4(byte[] byteaBytes, long trimSize) {
        this.trimSize = trimSize;
        this.byteaBytes = byteaBytes;
    }

    @Override
    public int read() throws IOException {
        final byte[] bytes = byteaBytes; //Avoid getfield opcode
        if (!(position < bytes.length))
            return -1;
        
        if (read++ == trimSize)
            return -1;
        
        byte b = bytes[position++];
        byte secondbyte;
        int thebyte;
        if (b == (byte)'\\') {
            if (!(position < bytes.length))
                return -1; //Its data error in fact
            secondbyte = bytes[position++];
            if (secondbyte == (byte)'\\') {
                //escaped \
                return (byte)'\\';
            } else {
                if (!(position < bytes.length-1))
                    return -1; //Or throw error?
                thebyte = (secondbyte - 48) * 64 
                        + (bytes[position++] - 48) * 8
                        + (bytes[position++] - 48);
                return thebyte;
            }
        }else {
            return b;
        }
    }
    
}
